summaryrefslogtreecommitdiffstats
path: root/src/ci/run.sh
diff options
context:
space:
mode:
Diffstat (limited to 'src/ci/run.sh')
-rwxr-xr-xsrc/ci/run.sh25
1 files changed, 22 insertions, 3 deletions
diff --git a/src/ci/run.sh b/src/ci/run.sh
index 48fb40d6a..b8cb758bf 100755
--- a/src/ci/run.sh
+++ b/src/ci/run.sh
@@ -8,7 +8,7 @@ fi
if [ "$NO_CHANGE_USER" = "" ]; then
if [ "$LOCAL_USER_ID" != "" ]; then
- useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
+ id -u user &>/dev/null || useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
export HOME=/home/user
unset LOCAL_USER_ID
@@ -154,13 +154,25 @@ fi
# check for clock drifts. An HTTP URL is used instead of HTTPS since on Azure
# Pipelines it happened that the certificates were marked as expired.
datecheck() {
- echo "== clock drift check =="
+ # If an error has happened, we do not want to start a new group, because that will collapse
+ # a previous group that might have contained the error log.
+ exit_code=$?
+
+ if [ $exit_code -eq 0 ]
+ then
+ echo "::group::Clock drift check"
+ fi
+
echo -n " local time: "
date
echo -n " network time: "
curl -fs --head http://ci-caches.rust-lang.org | grep ^Date: \
| sed 's/Date: //g' || true
- echo "== end clock drift check =="
+
+ if [ $exit_code -eq 0 ]
+ then
+ echo "::endgroup::"
+ fi
}
datecheck
trap datecheck EXIT
@@ -171,12 +183,16 @@ trap datecheck EXIT
# sccache server at the start of the build, but no need to worry if this fails.
SCCACHE_IDLE_TIMEOUT=10800 sccache --start-server || true
+# Our build may overwrite config.toml, so we remove it here
+rm -f config.toml
+
$SRC/configure $RUST_CONFIGURE_ARGS
retry make prepare
# Display the CPU and memory information. This helps us know why the CI timing
# is fluctuating.
+echo "::group::Display CPU and Memory information"
if isMacOS; then
system_profiler SPHardwareDataType || true
sysctl hw || true
@@ -186,6 +202,7 @@ else
cat /proc/meminfo || true
ncpus=$(grep processor /proc/cpuinfo | wc -l)
fi
+echo "::endgroup::"
if [ ! -z "$SCRIPT" ]; then
echo "Executing ${SCRIPT}"
@@ -218,4 +235,6 @@ if [ "$RUN_CHECK_WITH_PARALLEL_QUERIES" != "" ]; then
CARGO_INCREMENTAL=0 ../x check
fi
+echo "::group::sccache stats"
sccache --show-stats || true
+echo "::endgroup::"